/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: echonet_class.h 101 2015-06-02 15:37:23Z coas-nagasima $
 */

#ifndef ECHONET_CLASS_H
#define ECHONET_CLASS_H

/* ZT[֘A@ */
#define EOJ_X1_SENSOR 0x00

/* 󒲊֘A@ */
#define EOJ_X1_AIR_CONDITIONER 0x01

/* ZEݔ֘A@ */
#define EOJ_X1_AMENITY 0x02

/* EƎ֘A@ */
#define EOJ_X1_HOUSEWORK 0x03

/* N֘A@ */
#define EOJ_X1_WELLNESS 0x04

/* ǗE֘A@ */
#define EOJ_X1_CONTROLLER 0x05

/* AV֘A@ */
#define EOJ_X1_AUDIO_VISUAL 0x06

/* vt@C */
#define EOJ_X1_PROFILE 0x0E

/* [U[` */
#define EOJ_X1_USER_DEFINED 0x0F

/*
 * ZT֘A@NXO[v *
 */
/* KXRZT */
#define EOJ_X2_GAS_LEAK_SENSOR 0x01

/* hƃZT */
#define EOJ_X2_CRIME_PREVENTION_SENSOR 0x02

/* {^ */
#define EOJ_X2_EMERGENCY_BUTTON 0x03

/* ~}pZT */
#define EOJ_X2_FIRST_AID_SENSOR 0x04

/* nkZT */
#define EOJ_X2_EARTHQUAKE_SENSOR 0x05

/* RdZT */
#define EOJ_X2_ELECTRIC_LEAK_SENSOR 0x06

/* ľmZT */
#define EOJ_X2_HUMAN_DETECTION_SENSOR 0x07

/* qZT */
#define EOJ_X2_VISITOR_SENSOR 0x08

/* ĂяoZT */
#define EOJ_X2_CALL_SENSOR 0x09

/* IZT */
#define EOJ_X2_CONDENSATION_SENSOR 0x0A

/* CZT */
#define EOJ_X2_AIR_POLLUTION_SENSOR 0x0B

/* _fZT */
#define EOJ_X2_OXYGEN_SENSOR 0x0C

/* ƓxZT */
#define EOJ_X2_ILLUMINANCE_SENSOR 0x0D

/* ZT */
#define EOJ_X2_SOUND_SENSOR 0x0E

/* ZT */
#define EOJ_X2_MAILING_SENSOR 0x0F

/* d׃ZT */
#define EOJ_X2_WEIGHT_SENSOR 0x10

/* xZT */
#define EOJ_X2_TEMPERATURE_SENSOR 0x11

/* xZT */
#define EOJ_X2_HUMIDITY_SENSOR 0x12

/* JZT */
#define EOJ_X2_RAIN_SENSOR 0x13

/* ʃZT */
#define EOJ_X2_WATER_LEVEL_SENSOR 0x14

/* CʃZT */
#define EOJ_X2_BATH_WATER_LEVEL_SENSOR 0x15

/* CオZT */
#define EOJ_X2_BATH_HEATING_STATUS_SENSOR 0x16

/* RZT */
#define EOJ_X2_WATER_LEAK_SENSOR 0x17

/* ӂZT */
#define EOJ_X2_WATER_OVERFLOW_SENSOR 0x18

/* ΍ЃZT */
#define EOJ_X2_FIRE_SENSOR 0x19

/* ^oRZT */
#define EOJ_X2_CIGARETTE_SMOKE_SENSOR 0x1A

/* bnQZT */
#define EOJ_X2_CO2_SENSOR 0x1B

/* KXZT */
#define EOJ_X2_GAS_SENSOR 0x1C

/* unbZT */
#define EOJ_X2_VOC_SENSOR 0x1D

/* ZT */
#define EOJ_X2_DIFFERENTIAL_PRESSURE_SENSOR 0x1E

/* ZT */
#define EOJ_X2_AIR_SPEED_SENSOR 0x1F

/* LZT */
#define EOJ_X2_ODOR_SENSOR 0x20

/* ZT */
#define EOJ_X2_FLAME_SENSOR 0x21

/* d͗ʃZT */
#define EOJ_X2_ELECTRIC_ENERGY_SENSOR 0x22

/* dʃZT */
#define EOJ_X2_CURRENT_VALUE_SENSOR 0x23

/* ZT */
#define EOJ_X2_DAYLIGHT_SENSOR 0x24

/* ʃZT */
#define EOJ_X2_WATER_FLOW_RATE_SENSOR 0x25

/* ZT */
#define EOJ_X2_MICROMOTION_SENSOR 0x26

/* ʉ߃ZT */
#define EOJ_X2_PASSAGE_SENSOR 0x27

/* ݏZT */
#define EOJ_X2_BED_PRESENCE_SENSOR 0x28

/* JZT */
#define EOJ_X2_OPEN_CLOSE_SENSOR 0x29

/* ʃZT */
#define EOJ_X2_ACTIVITY_AMOUNT_SENSOR 0x2A

/* l̈ʒuZT */
#define EOJ_X2_HUMAN_BODY_LOCATION_SENSOR 0x2B

/* ZT */
#define EOJ_X2_SNOW_SENSOR 0x2C

/*
 * 󒲊֘A@NXO[v *
 */
/* ƒpGAR */
#define EOJ_X2_HOME_AIR_CONDITIONER 0x30

/* ╗@ */
#define EOJ_X2_COLD_BLASTER 0x31

/* @ */
#define EOJ_X2_ELECTRIC_FAN 0x32

/* C */
#define EOJ_X2_VENTILATION_FAN 0x33

/* 󒲊C */
#define EOJ_X2_AIR_CONDITIONING_VENTILATION_FAN 0x34

/* C */
#define EOJ_X2_AIR_CLEANER 0x35

/* ╗ */
#define EOJ_X2_COLD_BLAST_FAN 0x36

/* T[L[^ */
#define EOJ_X2_CIRCULATOR 0x37

/* @ */
#define EOJ_X2_DEHUMIDIFIER 0x38

/*  */
#define EOJ_X2_HUMIDIFIER 0x39

/* V */
#define EOJ_X2_CEILING_FAN 0x3A

/* dC */
#define EOJ_X2_ELECTRIC_KOTATSU 0x3B

/* dC */
#define EOJ_X2_ELECTRIC_HEATING_PAD 0x3C

/* dCѕz */
#define EOJ_X2_ELECTRIC_BLANKET 0x3D

/* Xg[u */
#define EOJ_X2_SPACE_HEATER 0x3E

/* plq[^ */
#define EOJ_X2_PANEL_HEATER 0x3F

/* dCJ[ybg */
#define EOJ_X2_ELECTRIC_CARPET 0x40

/* tAq[^ */
#define EOJ_X2_FLOOR_HEATER 0x41

/* dCg[ */
#define EOJ_X2_ELECTRIC_HEATER 0x42

/* t@q[^ */
#define EOJ_X2_FAN_HEATER 0x43

/* [d */
#define EOJ_X2_BATTERY_CHARGER 0x44

/* ƖppbP[WGAR@ */
#define EOJ_X2_PACKAGE_TYPE_COMMERCIAL_AIR_CONDITIONER_INDOOR_UNIT 0x45

/* ƖppbP[WGARO@ */
#define EOJ_X2_PACKAGE_TYPE_COMMERCIAL_AIR_CONDITIONER_OUTDOOR_UNIT 0x46

/* ƖppbP[WGAR~Mjbg */
#define EOJ_X2_PACKAGE_TYPE_COMMERCIAL_AIR_CONDITIONER_THERMAL_STORAGE_UNIT 0x47

/* Ɩpt@RCjbg */
#define EOJ_X2_COMMERCIAL_FAN_COIL_UNIT 0x48

/* Ɩp󒲗M(`[) */
#define EOJ_X2_COMMERCIAL_AIR_CONDITIONING_COLD_SOURCE_CHILLER 0x49

/* Ɩp󒲉M({C[) */
#define EOJ_X2_COMMERCIAL_AIR_CONDITIONING_HEAT_SOURCE_BOILER 0x50

/* ƖpVAV */
#define EOJ_X2_AIR_CONDITIONING_VAV_FOR_COMMERCIAL_APPLICATION 0x51

/* Ɩp󒲃GAnhOjbg */
#define EOJ_X2_AIR_HANDLING_UNIT_AIR_CONDITIONING_FOR_COMMERCIAL_APPLICATION 0x52

/* jbgN[[ */
#define EOJ_X2_UNIT_COOLER 0x53

/* ƖpRfVOjbg */
#define EOJ_X2_CONDENSING_UNIT_FOR_COMMERCIAL_APPLICATION 0x54

/*
 * ZEݔ֘A@NXO[v *
 */
/* duCh */
#define EOJ_X2_ELECTRICALLY_OPERATED_SHADE 0x60

/* dVb^[ */
#define EOJ_X2_ELECTRICALLY_OPERATED_SHUTTER 0x61

/* dJ[e */
#define EOJ_X2_ELECTRICALLY_OPERATED_CURTAIN 0x62

/* dJ */
#define EOJ_X2_ELECTRICALLY_OPERATED_STORM_WINDOW 0x63

/* dK[W */
#define EOJ_X2_ELECTRICALLY_OPERATED_DOOR 0x64

/* dV */
#define EOJ_X2_ELECTRICALLY_OPERATED_SKYLIGHT 0x65

/* I[jOi悯j */
#define EOJ_X2_AWNING 0x66

/* Uipj */
#define EOJ_X2_GARDEN_SPRINKLER 0x67

/* Ui΍Зpj */
#define EOJ_X2_FIRE_SPRINKLER 0x68

/*  */
#define EOJ_X2_FOUNTAIN 0x69

/* uԓ */
#define EOJ_X2_INSTANTANEOUS_WATER_HEATERS 0x6A

/* dC */
#define EOJ_X2_ELECTRIC_WATER_HEATER 0x6B

/* zM */
#define EOJ_X2_SOLAR_WATER_HEATER 0x6C

/* z|v */
#define EOJ_X2_CIRCULATION_PUMP 0x6D

/* dC֍i֍Ag[֍Ȃǁj */
#define EOJ_X2_BIDET_EQUIPPED_TOILET 0x6E

/* dC */
#define EOJ_X2_ELECTRIC_KEY 0x6F

/* KX */
#define EOJ_X2_GAS_LINE_VALVE 0x70

/* z[TEi */
#define EOJ_X2_HOME_SAUNA 0x71

/* uԎ */
#define EOJ_X2_HOT_WATER_GENERATOR 0x72

/* g[@ */
#define EOJ_X2_BATHROOM_DRYER 0x73

/* z[Gx[^ */
#define EOJ_X2_HOME_ELEVATOR 0x74

/* dԎd؂ */
#define EOJ_X2_ELECTRICALLY_OPERATED_ROOM_DIVIDER 0x75

/* gXt@ */
#define EOJ_X2_HORIZONTAL_TRANSFER 0x76

/* d */
#define EOJ_X2_ELECTRICALLY_OPERATED_CLOTHES_DRYING_POLE 0x77

/* 򉻑 */
#define EOJ_X2_SEPTIC_TANK 0x78

/* Zpzd */
#define EOJ_X2_HOME_SOLAR_POWER_GENERATION 0x79

/* ≷M@ */
#define EOJ_X2_COLD_AND_HOT_WATER_HEAT_SOURCE_EQUIPMENT 0x7A

/* g[ */
#define EOJ_X2_FLOOR_HEATING 0x7B

/* Rdr */
#define EOJ_X2_FUEL_CELL 0x7C

/* ~dr */
#define EOJ_X2_STORAGE_BATTERY 0x7D

/* dCԏ[dVXe */
#define EOJ_X2_ELECTRIC_VEHICLE 0x7E

/* d͗ʃ[^ */
#define EOJ_X2_ELECTRIC_ENERGY_METER 0x80

/* ʃ[^ */
#define EOJ_X2_WATER_FLOW_METER 0x81

/* KX[^ */
#define EOJ_X2_GAS_METER 0x82

/* LPKX[^ */
#define EOJ_X2_LP_GAS_METERS 0x83

/* v */
#define EOJ_X2_CLOCK 0x84

/* hA */
#define EOJ_X2_AUTOMATIC_DOOR 0x85

/* ƖpGx[^ */
#define EOJ_X2_COMMERCIAL_ELEVATOR 0x86

/* dՃ[^O */
#define EOJ_X2_DISTRIBUTION_PANEL_METERING 0x87

/* X}[gd͗ʃ[^ */
#define EOJ_X2_SMART_ELECTRIC_ENERGY_METER 0x88

/* X}[gKX[^ */
#define EOJ_X2_SMART_GAS_METER 0x89

/* ʏƖ */
#define EOJ_X2_GENERAL_LIGHTING_CLASS 0x90

/* Ɩ */
#define EOJ_X2_EMERGENCY_LIGHTING 0x99

/* ݔƖ */
#define EOJ_X2_EQUIPMENT_LIGHT 0x9D

/* uU[ */
#define EOJ_X2_BUZZER 0xA0

/*
 * EƎ֘A@NXO[v *
 */
/* R[q[[J */
#define EOJ_X2_COFFEE_MACHINE 0xB0

/* R[q[~ */
#define EOJ_X2_COFFEE_MILL 0xB1

/* dC|bg */
#define EOJ_X2_ELECTRIC_HOT_WATER_POT 0xB2

/* dC */
#define EOJ_X2_ELECTRIC_STOVE 0xB3

/* g[X^ */
#define EOJ_X2_TOASTER 0xB4

/* W[TE~LT */
#define EOJ_X2_JUICER_FOOD_MIXER 0xB5

/* t[hvZbT */
#define EOJ_X2_FOOD_PROCESSOR 0xB6

/* Ⓚ① */
#define EOJ_X2_REFRIGERATOR_FREEZER 0xB7

/* I[uW */
#define EOJ_X2_COMBINATION_MICROWAVE_OVEN 0xB8

/* NbLOq[^ */
#define EOJ_X2_COOKING_HEATER 0xB9

/* I[u */
#define EOJ_X2_OVEN 0xBA

/* ъ */
#define EOJ_X2_RICE_COOKER 0xBB

/* dqW[ */
#define EOJ_X2_ELECTRONIC_JAR 0xBC

/* H􂢋@ */
#define EOJ_X2_DISH_WASHER 0xBD

/* H튣@ */
#define EOJ_X2_DISH_DRYER 0xBE

/* dC@ */
#define EOJ_X2_ELECTRIC_RICE_CAKE_COOKER 0xBF

/* ۉ@ */
#define EOJ_X2_KEEP_WARM_MACHINE 0xC0

/* ċ@ */
#define EOJ_X2_RICE_MILL 0xC1

/* p@ */
#define EOJ_X2_AUTOMATIC_BREAD_COOKER 0xC2

/* X[NbJ[ */
#define EOJ_X2_SLOW_COOKER 0xC3

/* dCЕ@ */
#define EOJ_X2_ELECTRIC_PICKLES_COOKER 0xC4

/* @ */
#define EOJ_X2_WASHING_MACHINE 0xC5

/* ߗފ@ */
#define EOJ_X2_CLOTH_DRYER 0xC6

/* dCAC */
#define EOJ_X2_ELECTRIC_IRON 0xC7

/* Y{vbT */
#define EOJ_X2_TROUSER_PRESS 0xC8

/* ӂƂ񊣑@ */
#define EOJ_X2_FUTON_DRYER 0xC9

/* E@ */
#define EOJ_X2_SMALL_ARTICLE_SHOES_DRYER 0xCA

/* dC|@iZgN[i܂ށj */
#define EOJ_X2_ELECTRIC_VACUUM_CLEANER 0xCB

/* fBX|[U */
#define EOJ_X2_DISPOSER 0xCC

/* dC@ */
#define EOJ_X2_ELECTRIC_MOSQUITO_CATCHER 0xCD

/* ƖpV[P[X */
#define EOJ_X2_COMMERCIAL_SHOW_CASE 0xCE

/* Ɩp① */
#define EOJ_X2_COMMERCIAL_REFRIGERATOR 0xCF

/* ƖpzbgP[X */
#define EOJ_X2_COMMERCIAL_HOT_CASE 0xD0

/* ƖptC[ */
#define EOJ_X2_COMMERCIAL_FRYER 0xD1

/* ƖpdqW */
#define EOJ_X2_COMMERCIAL_MICROWAVE_OVEN 0xD2

/* 󊣑@ */
#define EOJ_X2_WASHER_AND_DRYER 0xD3

/*
 * N֘A@NXO[v *
 */
/* ̏dv */
#define EOJ_X2_WEIGHING_MACHINE 0x01

/* ̉v */
#define EOJ_X2_CLINICAL_THERMOMETER 0x02

/* v */
#define EOJ_X2_BLOOD_PRESSURE_METER 0x03

/* lv */
#define EOJ_X2_BLOOD_SUGAR_METER 0x04

/* ̎bv */
#define EOJ_X2_BODY_FAT_METER 0x05

/*
 * ǗE֘A@NXO[v *
 */
/* ZLAʐMpLݒm[h */
#define EOJ_X2_SECURE_COMMUNICATION_SHARED_KEY_SETUP_NODE 0xFC

/* XCb`iJEMA/HA[qΉj */
#define EOJ_X2_SWITCH 0xFD

/* gђ[ */
#define EOJ_X2_PORTABLE_TERMINAL 0xFE

/* Rg[ */
#define EOJ_X2_CONTROLLER 0xFF

/*
 * `u֘A@NXO[v *
 */
/* fBXv[ */
#define EOJ_X2_DISPLAY 0x01

/* er */
#define EOJ_X2_TELEVISION 0x02

/*
 * vt@CNXO[v *
 */
/* m[hvt@C */
#define EOJ_X2_NODE_PROFILE 0xF0

#endif /* ECHONET_CLASS_H */
