/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: uip_target_config.c 101 2015-06-02 15:37:23Z coas-nagasima $
 */

/*
 *  ^[QbgˑW[iRX63Npj
 */

#include <sil.h>

#include <uip-conf.h>
#ifdef __RX
#include <rx630_ccrx/rx630.h>
#else
#include <rx630_msvc/rx630.h>
#endif

/*
 *  rx62n_bus_init -- ^[Qbgˑ̃oX̏
 */

void
rx62n_bus_init (void)
{
	/* C[TlbgERg[̓ */
	sil_wrh_mem((uint16_t *)SYSTEM_PRCR_ADDR, (uint16_t)0xA502);	/* ݋ */
	sil_wrw_mem((uint32_t *)SYSTEM_MSTPCRB_ADDR,
		sil_rew_mem((uint32_t *)SYSTEM_MSTPCRB_ADDR) & ~SYSTEM_MSTPCRB_MSTPB15_BIT);
	sil_wrh_mem((uint16_t *)SYSTEM_PRCR_ADDR, (uint16_t)0xA500);	/* ݋֎~ */

	/* EtherNETL */
	/* PA3`5 RMII_MDIO, RMII_MDC, RMII_LINKSTA */
	sil_wrb_mem((uint8_t *)PORTA_PMR_ADDR,
		sil_reb_mem((uint8_t *)PORTA_PMR_ADDR) | (1 << 3) | (1 << 4) | (1 << 5));
	/* PB0`7 RXD1, RXD0, REF50CK, RX-ER, TXD-EN, TXD0, TXD1, CRS */
	sil_wrb_mem((uint8_t *)PORTB_PMR_ADDR,
		sil_reb_mem((uint8_t *)PORTB_PMR_ADDR) | 0xFF);

	/* ݃veNgWX^̐ݒ PFSWErbgւ݂̏ */
	sil_wrb_mem((uint8_t *)(MPC_PWPR_ADDR) , 0x00);
	/* ݃veNgWX^̐ݒ PxxFSWX^ւ݂̏ */
	sil_wrb_mem((uint8_t *)(MPC_PWPR_ADDR) , 0x40);

	/* PA3ET_MDIOƂ */
	sil_wrb_mem((uint8_t *)MPC_PA3PFS_ADDR, 0x11); 
	/* PA4ET_MDCƂ */
	sil_wrb_mem((uint8_t *)MPC_PA4PFS_ADDR, 0x11); 
	/* PA5ET_LINKSTAƂ */
	sil_wrb_mem((uint8_t *)MPC_PA5PFS_ADDR, 0x11); 

	/* PB0RXD1Ƃ */
	sil_wrb_mem((uint8_t *)MPC_PB0PFS_ADDR, 0x12);
	/* PB1RXD0Ƃ */
	sil_wrb_mem((uint8_t *)MPC_PB1PFS_ADDR, 0x12);
	/* PB2REF50CKƂ */
	sil_wrb_mem((uint8_t *)MPC_PB2PFS_ADDR, 0x12);
	/* PB3RX-ERƂ */
	sil_wrb_mem((uint8_t *)MPC_PB3PFS_ADDR, 0x12);
	/* PB4TXD-ENƂ */
	sil_wrb_mem((uint8_t *)MPC_PB4PFS_ADDR, 0x12);
	/* PB5TXD0Ƃ */
	sil_wrb_mem((uint8_t *)MPC_PB5PFS_ADDR, 0x12);
	/* PB6TXD1Ƃ */
	sil_wrb_mem((uint8_t *)MPC_PB6PFS_ADDR, 0x12);
	/* PB7CRSƂ */
	sil_wrb_mem((uint8_t *)MPC_PB7PFS_ADDR, 0x12);

	/* ݃veNgWX^̐ݒ ݂֎~ */
	sil_wrb_mem((uint8_t *)(MPC_PWPR_ADDR) , 0x80);
}

/*
 *  rx62n_inter_init -- ^[Qbgˑ݂̊̏
 */

void
rx62n_inter_init (void)
{
}
